      subroutine instability_atomcell_esurf
      use variables
      use constants
      use variables_inst
      use rp_param
      double precision,allocatable :: rx_store(:),ry_store(:),rz_store(:)
      double precision :: hmat_store(3,3)
      double precision :: inf_str, inf_dis
      double precision,allocatable :: dfx(:),dfy(:),dfz(:)
      double precision,allocatable :: hessian(:,:),hessian_cell(:,:),hessian_ac(:,:)
      double precision :: emin,emax,xx
      double precision,allocatable :: vec(:)
      character(13) :: filename
!      double precision :: hessian_tmp(n*3,n*3) !!!
      double precision,allocatable :: hessian_tmp(:,:) !!!

      double precision :: rlb=-1.0d100, rub=1.0d100
      double precision,allocatable :: AR(:,:),AI(:,:),EVR(:,:),EVI(:,:) &
      ,E(:),EI(:),FV1(:),FV2(:),FV3(:),FV4(:),FV5(:),FV6(:),FV7(:),FV8(:),FM1(:,:),IV1(:) &
      ,WORK(:)
      integer, allocatable :: nod(:),nindx(:)
      integer :: irmv(6)
      double precision,allocatable :: tder(:),disp1x(:),disp1y(:),disp1z(:)
      double precision,allocatable ::         disp2x(:),disp2y(:),disp2z(:)
      character (4) :: stri, strj

! degree of freedom: atomcell
      nofpbc=0
      if (pbcx) nofpbc=nofpbc+1; if (pbcy) nofpbc=nofpbc+1; if (pbcz) nofpbc=nofpbc+1
      if (nofpbc==1) then
         if (iedg==icnt) nn=n*3-3+3
         if (iedg/=icnt) nn=n*3-4+3
      endif
      if (nofpbc==2) nn=n*3-3+3;   if (nofpbc==3) nn=n*3-3+6
      if (nofpbc==0) stop 'instability_atomcell.F: NO PBC is currently not supported.'

      allocate (ar(nn,nn),ai(nn,nn),evr(nn,nn),evi(nn,nn),e(nn),ei(nn))
      allocate (fv1(nn),fv2(nn),fv3(nn),fv4(nn),fv5(nn))
      allocate (fv6(nn),fv7(nn),fv8(nn),fm1(2,nn),iv1(nn))
      allocate (work(nn*4))

      allocate (rx_store(n),ry_store(n),rz_store(n))
      allocate (hessian(n*3,n*3),hessian_cell(6,6),hessian_ac(n*3,6))
      allocate (hessian_tmp(n*3,n*3))
      allocate (vec(n))
      allocate (nindx(nn))
      allocate (tder(nn),disp1x(n),disp1y(n),disp1z(n),disp2x(n),disp2y(n),disp2z(n))

      hmat_store=hmat           ! Cell matrix save
      rx_store=rx; ry_store=ry; rz_store=rz ! Atom position save

      inf_str=0.01           ! Infinitesimal strain
      inf_dis=0.0005*ang        ! Infinitesimal displacement
      

!!!  Hessian: cell and atom-cell term
      do i=1,6
         hmat=hmat_store
         rx=rx_store; ry=ry_store; rz=rz_store
         
         exx=0.0d0; eyy=0.0d0; ezz=0.0d0
         eyz=0.0d0; ezx=0.0d0; exy=0.0d0
         if (i==1) exx=inf_str
         if (i==2) eyy=inf_str
         if (i==3) ezz=inf_str
         if (i==4) eyz=inf_str
         if (i==5) ezx=inf_str
         if (i==6) exy=inf_str
         strmat_set = 0.0d0
         strmat_set(1,1) = exx
         strmat_set(2,2) = eyy
         strmat_set(3,3) = ezz
         strmat_set(2,3) = eyz/2.0d0
         strmat_set(1,3) = ezx/2.0d0
         strmat_set(1,2) = exy/2.0d0
         strmat_set(3,2) = strmat_set(2,3)
         strmat_set(3,1) = strmat_set(1,3)
         strmat_set(2,1) = strmat_set(1,2)
         call strain
         call potential
         call calcstresstensor
         do j=1,6
            if (j==1) hessian_cell(i,j)=sgmmat(1,1)
            if (j==2) hessian_cell(i,j)=sgmmat(2,2)
            if (j==3) hessian_cell(i,j)=sgmmat(3,3)
            if (j==4) hessian_cell(i,j)=sgmmat(2,3)*2
            if (j==5) hessian_cell(i,j)=sgmmat(3,1)*2
            if (j==6) hessian_cell(i,j)=sgmmat(1,2)*2
         enddo
         do j=1,n
            hessian_ac((j-1)*3+1,i)=fx(j)
            hessian_ac((j-1)*3+2,i)=fy(j)
            hessian_ac((j-1)*3+3,i)=fz(j)
         enddo
         hmat=hmat_store
         rx=rx_store; ry=ry_store; rz=rz_store
         strmat_set=-strmat_set
         call strain
         call potential
         call calcstresstensor
         do j=1,6
            if (j==1) hessian_cell(i,j)=hessian_cell(i,j)-sgmmat(1,1)
            if (j==2) hessian_cell(i,j)=hessian_cell(i,j)-sgmmat(2,2)
            if (j==3) hessian_cell(i,j)=hessian_cell(i,j)-sgmmat(3,3)
            if (j==4) hessian_cell(i,j)=hessian_cell(i,j)-sgmmat(2,3)*2
            if (j==5) hessian_cell(i,j)=hessian_cell(i,j)-sgmmat(3,1)*2
            if (j==6) hessian_cell(i,j)=hessian_cell(i,j)-sgmmat(1,2)*2
         enddo
         do j=1,n
            hessian_ac((j-1)*3+1,i)=fx(j)-hessian_ac((i-1)*3+1,i)
            hessian_ac((j-1)*3+2,i)=fy(j)-hessian_ac((j-1)*3+2,i)
            hessian_ac((j-1)*3+3,i)=fz(j)-hessian_ac((j-1)*3+3,i)
         enddo
      enddo
      hessian_cell=hessian_cell/inf_str/2.0
! Restore original cell and atom config
      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store

!!!  Hessian: atom coordinates term
      print *,'Making atomonly matrix..'

      iexact=0 !!! 0: fast, otherwise: exact
      if (iexact==0) then
         atime=dtime(btime)
         if (TRIM(potential_func)=='StilWeb') then
            call sw_forceconst(hessian)
         else if ((TRIM(potential_func)=='GEAM').and.(TRIM(potential_arg)=='AM')) then
            call eam_geam_AM_forceconst(hessian)
         else
            stop 'Fast force-constant calc. is not available for this potential.'
         endif
         atime=dtime(btime)
         print *,'Fast done.',btime,'sec'
      else
         atime=dtime(btime)
         if (TRIM(potential_func)=='StilWeb') then
            call sw_forceconst(hessian_tmp)
         else if ((TRIM(potential_func)=='GEAM').and.(TRIM(potential_arg)=='AM')) then
            call eam_geam_AM_forceconst(hessian_tmp)
         endif
         atime=dtime(btime)
         print *,'Fast done.',btime,'sec'
         do i=1,n
            rx(i)=rx(i)+inf_dis
            call potential
            do j=1,n
               hessian((i-1)*3+1,(j-1)*3+1)=fx(j)
               hessian((i-1)*3+1,(j-1)*3+2)=fy(j)
               hessian((i-1)*3+1,(j-1)*3+3)=fz(j)
            enddo
            rx(i)=rx(i)-inf_dis*2.0
            call potential
            do j=1,n
               hessian((i-1)*3+1,(j-1)*3+1)=fx(j)-hessian((i-1)*3+1,(j-1)*3+1)
               hessian((i-1)*3+1,(j-1)*3+2)=fy(j)-hessian((i-1)*3+1,(j-1)*3+2)
               hessian((i-1)*3+1,(j-1)*3+3)=fz(j)-hessian((i-1)*3+1,(j-1)*3+3)
            enddo
            rx(i)=rx(i)+inf_dis
            
            ry(i)=ry(i)+inf_dis
            call potential
            do j=1,n
               hessian((i-1)*3+2,(j-1)*3+1)=fx(j)
               hessian((i-1)*3+2,(j-1)*3+2)=fy(j)
               hessian((i-1)*3+2,(j-1)*3+3)=fz(j)
            enddo
            ry(i)=ry(i)-inf_dis*2.0
            call potential
            do j=1,n
               hessian((i-1)*3+2,(j-1)*3+1)=fx(j)-hessian((i-1)*3+2,(j-1)*3+1)
               hessian((i-1)*3+2,(j-1)*3+2)=fy(j)-hessian((i-1)*3+2,(j-1)*3+2)
               hessian((i-1)*3+2,(j-1)*3+3)=fz(j)-hessian((i-1)*3+2,(j-1)*3+3)
            enddo
            ry(i)=ry(i)+inf_dis         
            
            rz(i)=rz(i)+inf_dis
            call potential
            do j=1,n
               hessian((i-1)*3+3,(j-1)*3+1)=fx(j)
               hessian((i-1)*3+3,(j-1)*3+2)=fy(j)
               hessian((i-1)*3+3,(j-1)*3+3)=fz(j)
            enddo
            rz(i)=rz(i)-inf_dis*2.0
            call potential
            do j=1,n
               hessian((i-1)*3+3,(j-1)*3+1)=fx(j)-hessian((i-1)*3+3,(j-1)*3+1)
               hessian((i-1)*3+3,(j-1)*3+2)=fy(j)-hessian((i-1)*3+3,(j-1)*3+2)
               hessian((i-1)*3+3,(j-1)*3+3)=fz(j)-hessian((i-1)*3+3,(j-1)*3+3)
            enddo
            rz(i)=rz(i)+inf_dis         
         enddo
         hessian=hessian/inf_dis/2.0
         atime=dtime(btime)
         print *,'Exact done.',btime,'sec'
         
!!! compare exact and fast solutions
         zz=0.0
         do i=1,n*3
            do j=1,n*3
               xx=hessian(i,j)-hessian_tmp(i,j)
               if (xx.ne.0.0) then
                  if (hessian(i,j)==0.0) then
                     if (abs(hessian_tmp(i,j))>1.0) then
                        print *,i,j,hessian(i,j),hessian_tmp(i,j)
                     endif
                  else
                     yy=abs(xx/hessian(i,j)*100)
                     zz=max(yy,zz)
                     if (yy>10) then
                        print *,i,j,hessian(i,j),hessian_tmp(i,j),yy
                        ii=i/3;if (mod(i,3)==0) ii=ii+1
                        jj=j/3;if (mod(j,3)==0) jj=jj+1
                        xx=abs(rx(ii)-rx(jj)); yy=abs(ry(ii)-ry(jj)); zz=abs(rz(ii)-rz(jj))
                        if (xx>rc*2) xx=xx-hmat(1,1)
                        if (yy>rc*2) yy=yy-hmat(2,2)
                        if (zz>rc*2) zz=zz-hmat(3,3)
                        print *,rc*2-sqrt(xx**2+yy**2+zz**2),rc*3-sqrt(xx**2+yy**2+zz**2)

                     endif
                     if ((yy>1).and.(abs(hessian(i,j))>1.0)) then
                        print *,i,j,hessian(i,j),hessian_tmp(i,j),yy
                     endif
                  endif
               endif
            enddo
         enddo
         print *,'Max error=',zz,'%'
         
      endif


      emax=-1.0d100
      do i=1,3*n; do j=1,3*n
         emax=max(abs(hessian(i,j)),emax)
      enddo; enddo
!      hessian=hessian/emax
      emax=-1.0d100
      do i=1,6; do j=1,6
         emax=max(abs(hessian_cell(i,j)),emax)
      enddo; enddo
!      hessian_cell=hessian_cell/emax
      do i=1,3*n; do j=1,6
         emax=max(abs(hessian_ac(i,j)),emax)
      enddo; enddo
!      hessian_ac=hessian_ac/emax

!!!
!      hessian_ac=0.0d0
!      hessian_cell=0.0d0
!      do i=1,6; hessian(i,i)=1.0d0; enddo

      if (.false.) then
         print *,'### HESSIAN MATRIX ###'
         do i=1,nn; do j=1,nn
            print *,i,j,hessian(i,j)
         enddo; enddo
      endif

! search one atom at edge and one near cell center
      if (iedg==0) then
         xmin=1.0d10; ymin=1.0d10; zmin=1.0d10
         do i=1,n
            if (rx(i)<xmin) then; xmin=rx(i); iedg=i; endif
            if (ry(i)<ymin) then; ymin=ry(i); iedg=i; endif
            if (rz(i)<zmin) then; zmin=rz(i); iedg=i; endif
         enddo
         xcnt=(hmat(1,1)+hmat(2,1)+hmat(3,1))/2.0
         ycnt=(hmat(1,2)+hmat(2,2)+hmat(3,2))/2.0
         zcnt=(hmat(1,3)+hmat(2,3)+hmat(3,3))/2.0
         rng=1.0d-11
888      icnt=0
         do i=1,n
            if ((abs(rx(i)-xcnt)<rng).and.(abs(ry(i)-ycnt)<rng).and.(abs(rz(i)-zcnt)<rng)) then
               icnt=i; exit
            endif
         enddo
         if (icnt==0) then; rng=rng*2.0; go to 888; endif
      endif
      
      print *,'Edge atom=',iedg,'(',real(rx(iedg)*1.0e10),real(ry(iedg)*1.0e10),real(rz(iedg)*1.0e10),') [ang]'
      print *,'Cent atom=',icnt,'(',real(rx(icnt)*1.0e10),real(ry(icnt)*1.0e10),real(rz(icnt)*1.0e10),') [ang]'

!      iedg=1; icnt=7
!!! --- Matrix set (removing some lines to meet DoF) ---
      if (nofpbc==3) then      ! --> atom icnt is fixed
         nrmv=3; irmv(1)=3*(icnt-1)+1; irmv(2)=3*(icnt-1)+2; irmv(3)=3*(icnt-1)+3
      else if (nofpbc==2) then ! --> atom icnt is fixed 
         nrmv=3; irmv(1)=3*(icnt-1)+1; irmv(2)=3*(icnt-1)+2; irmv(3)=3*(icnt-1)+3
      else if (nofpbc==1) then ! --> atom icnt is fixed, iedg is constrained
         stop 'instability atomcell: one-direction PBC is currently not supported.'
         if (iedg/=icnt) then
            nrmv=4; irmv(1)=3*(icnt-1)+1; irmv(2)=3*(icnt-1)+2; irmv(3)=3*(icnt-1)+3
            if (pbcx) irmv(4)=3*(iedg-1)
            if (pbcy) irmv(4)=3*(iedg-1)+1
            if (pbcz) irmv(4)=3*(iedg-1)+2
         else
            nrmv=3; irmv(1)=3*(icnt-1)+1; irmv(2)=3*(icnt-1)+2; irmv(3)=3*(icnt-1)+3
         endif
      endif

      indx=0
      do i=1,n*3
         do ii=1,nrmv
            if (i==irmv(ii)) go to 990
         enddo
         indx=indx+1
         nindx(indx)=i

         jndx=0
         do j=1,n*3
            do ii=1,nrmv
               if (j==irmv(ii)) go to 991
            enddo
            jndx=jndx+1

            ar(indx,jndx)=hessian(i,j)
            
991         continue
         enddo

990      continue
      enddo
      nhes=n*3-nrmv
      do i=1,nhes
         if (nofpbc==3) then
            do j=1,6
               ar(i,nhes+j)=hessian_ac(i,j)
               ar(nhes+j,i)=hessian_ac(i,j)
            enddo
         else if (nofpbc==2) then
            if (.not.(pbcz)) then
               ar(i,nhes+1)=hessian_ac(i,1); ar(nhes+1,i)=hessian_ac(i,1)
               ar(i,nhes+2)=hessian_ac(i,2); ar(nhes+2,i)=hessian_ac(i,2)
               ar(i,nhes+3)=hessian_ac(i,6); ar(nhes+3,i)=hessian_ac(i,6)
            else if (.not.(pbcx)) then
               ar(i,nhes+1)=hessian_ac(i,2); ar(nhes+1,i)=hessian_ac(i,2)
               ar(i,nhes+2)=hessian_ac(i,3); ar(nhes+2,i)=hessian_ac(i,3)
               ar(i,nhes+3)=hessian_ac(i,4); ar(nhes+3,i)=hessian_ac(i,4)
            else if (.not.(pbcy)) then
               ar(i,nhes+1)=hessian_ac(i,1); ar(nhes+1,i)=hessian_ac(i,1)
               ar(i,nhes+2)=hessian_ac(i,3); ar(nhes+2,i)=hessian_ac(i,3)
               ar(i,nhes+3)=hessian_ac(i,5); ar(nhes+3,i)=hessian_ac(i,5)
            endif
         endif
      enddo
      if (nofpbc==3) then
         do i=1,6
            do j=1,6
               ar(nhes+i,nhes+j)=hessian_cell(i,j)
            enddo
         enddo
      else if (nofpbc==2) then
         if (.not.(pbcz)) then
            ar(nhes+1,nhes+1)=hessian_cell(1,1)
            ar(nhes+1,nhes+2)=hessian_cell(1,2)
            ar(nhes+1,nhes+3)=hessian_cell(1,6)
            ar(nhes+2,nhes+1)=hessian_cell(2,1)
            ar(nhes+2,nhes+2)=hessian_cell(2,2)
            ar(nhes+2,nhes+3)=hessian_cell(2,6)
            ar(nhes+3,nhes+1)=hessian_cell(6,1)
            ar(nhes+3,nhes+2)=hessian_cell(6,2)
            ar(nhes+3,nhes+3)=hessian_cell(6,6)
         else if (.not.(pbcx)) then
            ar(nhes+1,nhes+1)=hessian_cell(2,2)
            ar(nhes+1,nhes+2)=hessian_cell(2,3)
            ar(nhes+1,nhes+3)=hessian_cell(2,4)
            ar(nhes+2,nhes+1)=hessian_cell(3,2)
            ar(nhes+2,nhes+2)=hessian_cell(3,3)
            ar(nhes+2,nhes+3)=hessian_cell(3,4)
            ar(nhes+3,nhes+1)=hessian_cell(4,2)
            ar(nhes+3,nhes+2)=hessian_cell(4,3)
            ar(nhes+3,nhes+3)=hessian_cell(4,4)
         else if (.not.(pbcy)) then
            ar(nhes+1,nhes+1)=hessian_cell(1,1)
            ar(nhes+1,nhes+2)=hessian_cell(1,3)
            ar(nhes+1,nhes+3)=hessian_cell(1,5)
            ar(nhes+2,nhes+1)=hessian_cell(3,1)
            ar(nhes+2,nhes+2)=hessian_cell(3,3)
            ar(nhes+2,nhes+3)=hessian_cell(3,5)
            ar(nhes+3,nhes+1)=hessian_cell(5,1)
            ar(nhes+3,nhes+2)=hessian_cell(5,3)
            ar(nhes+3,nhes+3)=hessian_cell(5,5)
         endif
      endif
         
      ai=0

!      do i=1,nn
!         write (6,'(6f12.5)') (ar(i,j),j=1,6)
!      enddo

      noc=nn
      print *,'Solving eigenvalue problem for atom+cell matrix..'
!      CALL EISPC(nn,nn,AR,AI,E,EVR,EVI,RLB,RUB,FV1,FV2,FV3 &
!      ,FV4,FV5,FV6,FV7,FV8,FM1,IV1,NOC)
      atime=dtime(btime)
      call DGEEV('N','V',nn,ar,nn,e,ei,evi,nn,evr,nn,work,nn*4,INFO)
      atime=dtime(btime)
      print *,'Eigenvalue problem solved.',btime,'sec'
!      call DGEEV('V','N',nn,ar,nn,e,ei,evr,nn,evi,nn,work,nn*4,INFO)

! Sort eigenvalues
!      write (6,'(6f10.5)') (e(j),j=1,6)

      allocate (nod(nn))
      do i=1,nn; nod(i)=i; enddo
      call sort(nn,e,nod)
!      print *,nod(1),nod(2),nod(3),nod(4),nod(5)

!      write (6,'(6f10.3)') (e(j),j=1,6)
!      write (6,*)
!      write (6,'(6f10.3)') (evr(j,nod(1)),j=1,6)
!      write (6,'(6f10.3)') (evr(j,nod(2)),j=1,6)
!      write (6,'(6f10.3)') (evr(j,nod(3)),j=1,6)
!      write (6,'(6f10.3)') (evr(j,nod(4)),j=1,6)
!      write (6,'(6f10.3)') (evr(j,nod(5)),j=1,6)
!      write (6,'(6f10.3)') (evr(j,nod(6)),j=1,6)

      write (6,'("### INSTABILITY ANALYSIS (ATOM+CELL) ###")')
      if (e(1)<0.0) write (6,'("Negative eigenvalue found:",e12.4)') e(1)
      write (6,'("MINIMUM EIGENVALUE (ATOM+CELL):",e12.4)') e(1)

      open (20,FILE='emin.d')
      if (continue_md) then
         do while(.true.)
            read (20,*,end=111) xx
         enddo
111      continue
      endif
      write (20,'(i8,10f10.5)') step,e(1),e(2),e(3),e(4),e(5),e(6),e(7),e(8),e(9),e(10)
      close (20)

! output data
      do i=1,10
         fx=0.0; fy=0.0; fz=0.0
         xx=0.0d0
!         do j=1,nn
         do j=1,nhes
            jj=nindx(j)
            if (jj/=0) then
               if (mod(jj,3)==1) then; jjj=(jj-1)/3+1; fx(jjj)=evr(j,nod(i)); endif
               if (mod(jj,3)==2) then; jjj=(jj-2)/3+1; fy(jjj)=evr(j,nod(i)); endif
               if (mod(jj,3)==0) then; jjj=(jj-3)/3+1; fz(jjj)=evr(j,nod(i)); endif
               xx=max(abs(evr(j,nod(i))),xx)
            endif
         enddo
         vec=sqrt(fx**2+fy**2+fz**2)
! write **.xsf
         xx=xx*5.0d8
         fx=fx/xx; fy=fy/xx; fz=fz/xx
         if (i== 1) call write_xsf(30,'atominst01.xsf')
         if (i== 2) call write_xsf(30,'atominst02.xsf')
         if (i== 3) call write_xsf(30,'atominst03.xsf')
         if (i== 4) call write_xsf(30,'atominst04.xsf')
         if (i== 5) call write_xsf(30,'atominst05.xsf')
         if (i== 6) call write_xsf(30,'atominst06.xsf')
         if (i== 7) call write_xsf(30,'atominst07.xsf')
         if (i== 8) call write_xsf(30,'atominst08.xsf')
         if (i== 9) call write_xsf(30,'atominst09.xsf')
         if (i==10) call write_xsf(30,'atominst10.xsf')
      enddo

! Energy curved surface
      i1=1
      i2=2

         hmat=hmat_store
         rx=rx_store; ry=ry_store; rz=rz_store

! Displacement vector
!         do j=1,nn
         disp1x=0.0d0;disp1y=0.0d0;disp1z=0.0d0
         disp2x=0.0d0;disp2y=0.0d0;disp2z=0.0d0
         do j=1,nhes
            jj=nindx(j)
            if (jj/=0) then
               if (mod(jj,3)==1) then; jjj=(jj-1)/3+1; disp1x(jjj)=evr(j,nod(i1)); endif
               if (mod(jj,3)==2) then; jjj=(jj-2)/3+1; disp1y(jjj)=evr(j,nod(i1)); endif
               if (mod(jj,3)==0) then; jjj=(jj-3)/3+1; disp1z(jjj)=evr(j,nod(i1)); endif
               if (mod(jj,3)==1) then; jjj=(jj-1)/3+1; disp2x(jjj)=evr(j,nod(i2)); endif
               if (mod(jj,3)==2) then; jjj=(jj-2)/3+1; disp2y(jjj)=evr(j,nod(i2)); endif
               if (mod(jj,3)==0) then; jjj=(jj-3)/3+1; disp2z(jjj)=evr(j,nod(i2)); endif
            endif
         enddo

!!!!! Calculation of energy curve
         if (inst_curve) then

!            disp1x=fx; disp1y=fy; disp1z=fz

            hmat=hmat_store
            rx=rx_store; ry=ry_store; rz=rz_store
            if (rpart) then
               call bookkeep_rp
            else
               call bookkeep
            endif
! Scaling eigenvectors so that |dr|^2=1
            xx=0.0d0; yy=0.0d0
            do j=1,n
               xx=xx+disp1x(j)**2+disp1y(j)**2+disp1z(j)**2
               yy=yy+disp2x(j)**2+disp2y(j)**2+disp2z(j)**2
            enddo
!            xx=sqrt(xx)*2.0d10
!            yy=sqrt(yy)*2.0d10
            xx=sqrt(xx)*0.8d10 * 3.0d0
            yy=sqrt(yy)*0.8d10 * 2.0d0
            disp1x=disp1x/xx; disp1y=disp1y/xx; disp1z=disp1z/xx
            disp2x=disp2x/yy; disp2y=disp2y/yy; disp2z=disp2z/yy
            evr(1:nn,nod(i1))=evr(1:nn,nod(i1))/xx
            evr(1:nn,nod(i2))=evr(1:nn,nod(i2))/yy
!         print *,dispx(1),evr(nhes+1,nod(i))
!            rx=rx+fx*xxfac; ry=ry+fy*xxfac; rz=rz+fz*xxfac

! Strain
            exx=0.0d0; eyy=0.0d0; ezz=0.0d0; eyz=0.0d0; ezx=0.0d0; exy=0.0d0
            open (21,FILE='esurface.d')

!            do iii=-50,50
            do iii=-40,40
               do jjj=-10,80
                  xxfac=1.0*dble(iii)
                  yyfac=1.0*dble(jjj)
                  if (nofpbc==3) then
                     exx=evr(nhes+1,nod(i1))*xxfac+evr(nhes+1,nod(i2))*yyfac
                     eyy=evr(nhes+2,nod(i1))*xxfac+evr(nhes+2,nod(i2))*yyfac
                     ezz=evr(nhes+3,nod(i1))*xxfac+evr(nhes+3,nod(i2))*yyfac
                     eyz=evr(nhes+4,nod(i1))*xxfac+evr(nhes+4,nod(i2))*yyfac
                     ezx=evr(nhes+5,nod(i1))*xxfac+evr(nhes+5,nod(i2))*yyfac
                     exy=evr(nhes+6,nod(i1))*xxfac+evr(nhes+6,nod(i2))*yyfac
                  else if (nofpbc==2) then
                     if (.not.(pbcz)) then
                        exx=evr(nhes+1,nod(i1))*xxfac+evr(nhes+1,nod(i2))*yyfac
                        eyy=evr(nhes+2,nod(i1))*xxfac+evr(nhes+2,nod(i2))*yyfac
                        exy=evr(nhes+3,nod(i1))*xxfac+evr(nhes+3,nod(i2))*yyfac
                     else if (.not.(pbcx)) then
                        eyy=evr(nhes+1,nod(i1))*xxfac+evr(nhes+1,nod(i2))*yyfac
                        ezz=evr(nhes+2,nod(i1))*xxfac+evr(nhes+2,nod(i2))*yyfac
                        eyz=evr(nhes+3,nod(i1))*xxfac+evr(nhes+3,nod(i2))*yyfac
                     else if (.not.(pbcy)) then
                        exx=evr(nhes+1,nod(i1))*xxfac+evr(nhes+1,nod(i2))*yyfac
                        ezz=evr(nhes+2,nod(i1))*xxfac+evr(nhes+2,nod(i2))*yyfac
                        ezx=evr(nhes+3,nod(i1))*xxfac+evr(nhes+3,nod(i2))*yyfac
                     endif
                  endif
!            exx=0.0d0; eyy=0.0d0; ezz=0.0d0; eyz=0.0d0; ezx=0.0d0; exy=0.0d0
                  hmat=hmat_store
                  rx=rx_store; ry=ry_store; rz=rz_store
                  strmat_set = 0.0d0
                  strmat_set(1,1) = exx
                  strmat_set(2,2) = eyy
                  strmat_set(3,3) = ezz
                  strmat_set(2,3) = eyz/2.0d0
                  strmat_set(1,3) = ezx/2.0d0
                  strmat_set(1,2) = exy/2.0d0
                  strmat_set(3,2) = strmat_set(2,3)
                  strmat_set(3,1) = strmat_set(1,3)
                  strmat_set(2,1) = strmat_set(1,2)
                  call strain
! Atom displacement
                  rx=rx_store; ry=ry_store; rz=rz_store
                  rx=rx+disp1x*xxfac+disp2x*yyfac
                  ry=ry+disp1y*xxfac+disp2y*yyfac
                  rz=rz+disp1z*xxfac+disp2z*yyfac
!            call bookkeep
                  call potential
                  write (21,*) iii,jjj,enpot
                  
                  if ((mod(iii,10)==0).and.(mod(jjj,10)==0)) then
                     call mkq
                     call conv_num_char(iii,stri)
                     call conv_num_char(jjj,strj)
                     call write_cfgs(22,'shift-'//stri//'-'//strj//'.cfg')
                  endif
               
!         if (i==5) then
!            if (iii==-10) call write_xsf(30,'i-10.xsf')
!            if (iii==0) call write_xsf(30,'i0.xsf')
!            if (iii==10) call write_xsf(30,'i10.xsf')
!         endif
               enddo
               write (21,*)
            enddo
            close (21)
         endif
!!!      enddo

      end

