      subroutine readcont
      use variables
      use constants
      character (2) :: species
      character (15) :: arg(8)
      integer :: narg
      
      open (30,FILE='CONT',status='old',action='read',iostat=ierr)
      if (ierr/=0) then
         print *,'CANNOT FIND <CONT> FILE'
!         print *,'MD STARTS FROM FIRST STEP'
!         return
         stop
      endif
      if (ierr==0) then
         print *,'READ CONT'
         read (30,*) species
!         read (30,*) potential_func
         call getargs(30,arg,narg)
         potential_func=TRIM(arg(1))
         if (narg/=1) then
            potential_arg=TRIM(arg(2))
         else
            potential_arg=''
         endif
         print *,'Atom: ',species,' Potential:',potential_func
         read (30,*) step
         read (30,*) n
         allocate (asp(n),wm(n))
         multisystem=0
         if ((species == 'Mu').or.(species == 'mu')) multisystem=1
         if (multisystem==0) then
            asp=species
         endif
         deallocate (rx,ry,rz,vx,vy,vz,ax,ay,az,bx,by,bz,cx,cy,cz)
         deallocate (fx,fy,fz,qx,qy,qz)
         deallocate (enpoteach,enkineach)
         allocate (enpoteach(n),enkineach(n))
         allocate (rx(n),ry(n),rz(n)) ! Positions
         if (diffusion) allocate (rxd(n),ryd(n),rzd(n))
!         if (diffusion) allocate (rxp(n),ryp(n),rzp(n))
         allocate (vx(n),vy(n),vz(n)) ! Velocities
         allocate (fx(n),fy(n),fz(n)) ! Forces
         allocate (qx(n),qy(n),qz(n)) ! Normalized positions
         allocate (ax(n),ay(n),az(n)) ! Accerelations (Second derivatives)
         allocate (bx(n),by(n),bz(n)) ! Third derivatives
         allocate (cx(n),cy(n),cz(n)) ! Fourth derivatives
         allocate (mfx(n),mfy(n),mfz(n)) ! Motion control
         allocate (qpx(n),qpy(n),qpz(n)) ! Positions for memory
         allocate (satom(n,3,3)) ! Atomic stress
         fx=0.0d0; fy=0.0d0; fz=0.0d0
         do i=1,n
            read (30,*) rx(i),ry(i),rz(i),asp(i),mfx(i),mfy(i),mfz(i)
            read (30,*) vx(i),vy(i),vz(i)
            read (30,*) ax(i),ay(i),az(i)
            read (30,*) bx(i),by(i),bz(i)
            read (30,*) cx(i),cy(i),cz(i)
         enddo
         read (30,*) s,sv,sa,sb,sc
         read (30,*) v,vv,va,vb,vc
         do i=1,3; do j=1,3
            read (30,*) hmat(i,j),hvmat(i,j),hamat(i,j),hbmat(i,j),hcmat(i,j)
            enddo; enddo
         close (30)
         open (30,FILE='CONT.VAR',status='old',action='read',iostat=ierr)
         if (ierr/=0) then
            print *,'CANNOT FIND <CONT.VAR> FILE'
            stop
         else
            read (30,*) dt, fire_alph, ffdtmax, ifire
         endif
         if (diffusion) then
            open (30,FILE='CONT.DIF',status='old',action='read',iostat=ierr)
            if (ierr/=0) then
               print *,'CANNOT FIND <CONT.DIF> FILE'
               stop
            else
               do i=1,n
                  read (30,*) rxd(i),ryd(i),rzd(i)
               enddo
            endif
         endif
         call inverse(hmat,hinmat)
         call calcvolume
         call mkq
      endif
 900  format (3(e20.12,1x))
 910  format (3(e25.18,1x),a3,1x,3(a2,1x))
 920  format (3(e25.18,1x),i10)
      end

